%define menus           %{!?_without_menus:1}%{?_without_menus:0}
%define section         free

Name:           argouml
Version:        0.17.5
Release:        4jpp
Epoch:          0
Summary:        A UML design tool with cognitive support
Group:          Development
License:        BSD
URL:            http://argouml.tigris.org/
# cvs -d:pserver:anoncvs@cvs.tigris.org:/cvs login
# cvs -z3 -d:pserver:anoncvs@cvs.tigris.org:/cvs co -r VERSION_0_17_5_F argouml
Source0:        argouml-cvs.tar.bz2
Source1:        %{name}-script
Source2:        %{name}-icon-16.png
Source3:        %{name}-icon-32.png
Source4:        %{name}-icon-48.png
Source5:        %{name}.desktop
Requires:       antlr
Requires:       dresden-ocl-argo
Requires:       gef = 0:0.10.11
Requires:       i18n-lib >= 0:0.1.3
Requires:       jakarta-commons-logging
Requires:       jmi
Requires:       jpackage-utils >= 0:1.5
Requires:       log4j
Requires:       nsuml
Requires:       swidgets
Requires:       toolbar >= 0:0.4
Requires:       xml-commons-apis
BuildRequires:  ant
BuildRequires:  antlr
BuildRequires:  docbook-style-xsl
BuildRequires:  dresden-ocl-argo
BuildRequires:  fop
BuildRequires:  gef = 0:0.10.11
BuildRequires:  i18n-lib >= 0:0.1.3
BuildRequires:  jimi
BuildRequires:  jmi
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  nsuml
BuildRequires:  saxon
BuildRequires:  saxon-fop
BuildRequires:  swidgets
BuildRequires:  toolbar >= 0:0.4
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis
Vendor:         JPackage Project
Distribution:   JPackage
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The goal of the ArgoUML project is to build an object oriented design
tool that is:
- A joy to use (we really mean it),
- Actually helpful to designers when they are making design decisions,
- Completely open source Java,
- Leading edge (supports the latest UML specifications),
- Modular and extensible,
- Integrated with the web and other Tigris tools.

%if %{menus}

%package        mdkmenu
Summary:        Mandrakelinux menu entry for ArgoUML
Group:          Development
Requires:       %{name} = %{epoch}:%{version}

%description    mdkmenu
%{summary}.

%package        legacymenu
Summary:        Legacy menu entry for ArgoUML
Group:          Text Editors/Integrated Development Environments (IDE)
Requires:       %{name} = %{epoch}:%{version}
Conflicts:      redhat-menus
Obsoletes:      %{name}-rhmenu
Provides:       %{name}-rhmenu

%description    legacymenu
%{summary}.

%endif

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
Javadoc for %{name}.

%package        manual
Group:          Development/Code Generators
Summary:        Manual for %{name}

%description    manual
Documentation for %{name}.

%prep
%setup -q -n %{name}
%__perl -p -i -e \
  's|File=.*|File=\${user.home}/.argouml/argouml.log|' \
  src_new/org/argouml/resource/*.lcf
# remove binary files
find . -name '*.jar' -exec %__rm -f {} \;
for dir in `find . -type d -name CVS`; do %__rm -rf $dir; done
%__rm -rf build/*
# clean up manifest
%__perl -p -i -e 's|^Class-Path.*$||s' src_new/templates/manifest.template

%build
export CLASSPATH=$(build-classpath antlr dresden-ocl-argo gef i18n-lib jmi nsuml swidgets toolbar xml-commons-apis)
%ant -Dbuild.sysclasspath=first \
     -buildfile src_new/build.xml \
     generateparser jar prepare-docs

export CLASSPATH=$(build-classpath fop saxon saxon-fop)
DOCBOOK_XSL=`rpm -ql docbook-style-xsl | %__grep /html/chunk.xsl \
| %__sed 's|/html/chunk.xsl||'`

if [ -z $DOCBOOK_XSL ]; then
  echo "Unable to find docbook xsl directory"
  exit 1
fi

pushd documentation
find . -type f -name '*.xsl' -exec \
%__perl -p -i -e 's|docbook-xsl-1.66.1|'$DOCBOOK_XSL'|g' {} \;
popd

if [ -z "$SGML_CATALOG_FILES" -a -e %{_sysconfdir}/sgml/catalog ] ; then
  export SGML_CATALOG_FILES=%{_sysconfdir}/sgml/catalog
fi

%ant -Dbuild.sysclasspath=first \
     -Ddocbook-xsl-root=$DOCBOOK_XSL \
     -buildfile documentation/build.xml \
     defaulthtml

%install
%__rm -rf %{buildroot}

# jars
%__mkdir_p %{buildroot}%{_javadir}
%__cp -a build/%{name}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
%__cp -a build/%{name}-model.jar %{buildroot}%{_javadir}/%{name}-model-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}.jar; do %__ln_s ${jar} `echo $jar| %__sed "s|-%{version}||g"`; done)
#%__install -D -p -m 644 build/%{name}.jar %{buildroot}%{_datadir}/%{name}/lib/%{name}.jar
#%__install -D -p -m 644 build/%{name}-model.jar %{buildroot}%{_datadir}/%{name}/lib/%{name}-model.jar

# scripts
%__install -D -p -m 755 %{SOURCE1} %{buildroot}%{_bindir}/%{name}

# javadoc
%__mkdir_p %{buildroot}%{_javadocdir}/%{name}-%{version}
%__cp -a build/javadocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
(cd %{buildroot}%{_javadocdir} && %__ln_s %{name}-%{version} %{name})

%if %{menus}

# mdk menu entry
%__mkdir_p %{buildroot}%{_menudir}
%__cat > %{buildroot}%{_menudir}/%{name} << EOF
?package(%{name}):\\
command="%{_bindir}/%{name}"\\
needs="X11"\\
icon="%{name}.png"\\
section="Applications/Development/Development environments"\\
title="ArgoUML" \
longtitle="A UML design tool with cognitive support"
EOF

# mdk icons
%__install -D -p -m 644 %{SOURCE2} %{buildroot}%{_miconsdir}/%{name}.png 
%__install -D -p -m 644 %{SOURCE3} %{buildroot}%{_iconsdir}/%{name}.png 
%__install -D -p -m 644 %{SOURCE4} %{buildroot}%{_liconsdir}/%{name}.png

# freedesktop.org menu entry
%__install -D -p -m 644 %{SOURCE5} \
  %{buildroot}%{_datadir}/applications/jpackage-%{name}.desktop

# icons for freedesktop.org and legacy menu entries
%__install -D -p -m 644 %{SOURCE2} \
  %{buildroot}%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
%__install -D -p -m 644 %{SOURCE3} \
  %{buildroot}%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
%__install -D -p -m 644 %{SOURCE4} \
  %{buildroot}%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
%__install -D -p -m 644 %{SOURCE4} \
  %{buildroot}%{_datadir}/pixmaps/%{name}.png

# legacy menu entry
%__install -D -p -m 644 %{SOURCE4} \
  %{buildroot}%{_sysconfdir}/X11/applnk/Development/%{name}.desktop

%endif

%clean
%__rm -rf %{buildroot}

%post
%__rm -rf %{_datadir}/%{name}/lib
(rmdir %{_datadir}/%{name} || :) > /dev/null 2>&1

%if %{menus}

%post mdkmenu
%update_menus
 
%postun mdkmenu
%clean_menus

%endif

%post javadoc
%__rm -f %{_javadocdir}/%{name}
%__ln_s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ $1 -eq 0 ]; then
  %__rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%doc src_new/README_database.sql src_new/README.txt src_new/*LICENSE.txt
%attr(0755,root,root) %{_bindir}/*
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}-model.jar
%{_javadir}/%{name}-model-%{version}.jar

%if %{menus}
%{_datadir}/applications/*-%{name}.desktop
%{_datadir}/icons/*/*/apps/*
%{_datadir}/pixmaps/%{name}.png

%files mdkmenu
%defattr(0644,root,root,0755)
%{_menudir}/%{name}
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_liconsdir}/%{name}.png

%files legacymenu
%defattr(0644,root,root,0755)
%{_sysconfdir}/X11/applnk/Development/*

%endif

%files javadoc
%defattr(0644,root,root,0755)
%dir %{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}-%{version}/*
%ghost %dir %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc build/documentation/defaulthtml/*

%changelog
* Tue Feb 22 2005 David Walluck <david@jpackage.org> 0:0.17.5-4jpp
- own non-versioned javadoc symlink
- fix javadoc %%post

* Tue Feb 22 2005 David Walluck <david@jpackage.org> 0:0.17.5-3jpp
- fix runtime CLASSPATH
- fix BuildRequires
- create argouml.log (if needed) on startup

* Tue Feb 22 2005 David Walluck <david@jpackage.org> 0:0.17.5-2jpp
- merge changelogs from previous versions

* Mon Feb 21 2005 David Walluck <david@jpackage.org> 0:0.17.5-1jpp
- 0.17.1
- s/menues/menus/g
- remove %%{appdir}
- add epoch to toolbar dependecy
- add pdf manual

* Tue Aug 24 2004 Fernando Nasser <fnasser@redhat.com> 0:0.15.4-4jpp
- Use new toolbar which now includes toolbutton

* Tue Aug 24 2004 Fernando Nasser <fnasser@redhat.com> 0:0.15.4-3jpp
- Build with nsuml 1.4.0

* Fri Aug 20 2004 Ralph Apel <r.apel at r-apel.de> 0:0.15.4-2jpp
- Build with ant-1.6.2
- Add option "--without manues" to not build menus

* Fri Aug 20 2004 Ralph Apel <r.apel@r-apel.de> 0:0.14-4jpp
- Build with ant-1.6.2
- Added option "--without menues" to not build menues

* Tue Mar 16 2004 David Walluck <david@jpackage.org> 0:0.15.4-1jpp
- 0.15.4
- require gef 0.10.2

* Sun Jan 25 2004 David Walluck <david@anti-microsoft.org> 0:0.14-3jpp
- remove old jars in %%post

* Sat Jan 24 2004 David Walluck <david@anti-microsoft.org> 0:0.14-2jpp
- use oldgef and oldi18n-lib
- move `Obsoletes: rhmenu' to legacymenu package and add `Provides: rhmenu'
- change the way the lib dir is created

* Fri Jan 23 2004 David Walluck <david@anti-microsoft.org> 0:0.15.3-1jpp
- release

* Fri Aug 29 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.14-1jpp
- Update to 0.14.
- More JPackage 1.5 updates.
- Include freedesktop.org menu entry in main package.
- Add non-versioned javadoc dir symlinks.

* Sat Apr 12 2003 David Walluck <david@anti-microsoft.org> 0:0.13.3-4jpp
- fix Patch1 and log4j configurations

* Fri Apr 11 2003 David Walluck <david@anti-microsoft.org> 0:0.13.3-3jpp
- more JPackage 1.5 updates
- multi-user fixes
- require xml-commons-apis for XML support

* Sun Apr 06 2003 David Walluck <david@anti-microsoft.org> 0:0.13.3-2jpp
- rebuild for JPackage 1.5
- no more bzip2 by popular demand

* Thu Mar 13 2003 Guillaume Rousse <guillomovitch@zarb.org> 0.13.3-1jpp
- 0.13.3

* Thu Feb 13 2003 Guillaume Rousse <guillomovitch@zarb.org> 0.13.2-1jpp
- 0.13.2 
- log4j patch merged upstream

* Mon Dec 02 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.13.1-1jpp
- 0.13.1
- regenerated patches

* Mon Oct 21 2002 David Walluck <david@anti-microsoft.org> 0.12-3jpp
- revert back to requiring gef >= 0.9.6

* Mon Oct 21 2002 David Walluck <david@anti-microsoft.org> 0.12-2jpp
- add %%gef_version macro
- require latest gef rpm
- change 'ln -s' to 'ln -sf'

* Thu Oct 17 2002 David Walluck <david@anti-microsoft.org> 0.12-1jpp
- 0.12
- bzip2 sources
- require jdepend (may not be needed now, but needed for CVS versions)
- rediff build patch

* Mon Oct 07 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.11.4-1jpp
- update from David Walluck <david@anti-microsoft.org>
 - 0.11.4
 - experimental log4j patch
- only remove symlinks if uninstalling, not upgrading

* Sun Sep 08 2002 Ville Skyttä <ville.skytta at iki.fi> 0.10.1-2jpp
- Add Red Hat menu item.
- Menu packages require main package.
- Fix menu entries' descriptions.
- Changed License to BSD.
- Use full URL to source tarball.

* Fri Sep 06 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.10.1-1jpp
- 0.10.1 
- new application policy

* Tue May 07 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.9-2jpp 
- hardcoded distribution and vendor tag
- group tag again

* Mon May 06 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.9-1jpp
- 0.9.9
- source system prefs in launch script
- inactivated jikes building

* Thu May 02 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.8-2jpp 
- distribution tag
- group tag
- source user prefs before configuration in launch script

* Tue Apr 09 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.8-1jpp
- 0.9.8

* Wed Mar 27 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.7-1jpp
- 0.9.7
- patch merged upstream

* Mon Mar 11 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.6-2jpp
- requires jaxp_parser2 instead of xerces-j1
- buildrequires ant >= 1.4.1-9jpp
- applied npe-fix.patch
- dropped xerces-j2 workaround

* Wed Mar 06 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.6-1jpp
- 0.9.6
- used png for icons
- section macro
- requires gef >= 0.9.6
- no more version dependecy on dresden-ocl
- no more dependency on log4j as gef already depends on it
- fixed missing macros for mdkmenu package

* Fri Jan 18 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.5-3jpp
- merged mdk and jpp branches
- additional sources in individual archives

* Fri Jan 11 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.5-2jpp
- requires antlr
- requires xerces-j1 instead of jaxp_parser (doesn't work with crimson)
- requires gef >= 0.9.5-5jpp as parasite class-path reference in manifest make crimson loading first
- corrected launch script
- javadoc in /usr/share/javadoc

* Tue Jan 08 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.9.5-1jpp
- 0.9.5
- requires log4j
- buildrequires log4j, junit and antlr
- javadoc package

* Wed Dec 05 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-8jpp
- Requires jpackage-utils

* Sat Dec 01 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-7jpp
- new launch script using functions library

* Sat Oct 06 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-6jpp
- used original tarball
- build patch for ant 1.4
- recreated source patch

* Sun Sep 30 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-5jpp
- more macros

* Fri Sep 28 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-4jpp
- first unified JPackage release
- GEF is now gef
- only dresden-ocl-argo is required
- unified launch script
- no more classpath in manifest
- s/jPackage/JPackage

* Thu Sep 13 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-3mdk
- menu entry
- used lower case for name
- spec cleanup

* Sat Jul 28 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-2mdk
- requires jaxp_parser
- use jaxp_parser alternative

* Sat Jun 23 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.8.1a-1mdk
- first Mandrake release
